;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro patch_show_image, state, REDRAW=redraw
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
COMMON image, img, header, N, M, a_dim, Nori, Mori

NN=N+2*state.par.overlap
MM=M+2*state.par.overlap

loadct, state.par.img_color, /SILENT

;show image (REDRAW if requested)
IF KEYWORD_SET(redraw) THEN BEGIN
  Widget_Control, state.id.ibase, Map=0
  Widget_Control, state.id.ikill, /destroy
  if state.par.cols*state.par.rows GT 1 then begin
             tooltip_str='left click to select, right click for options'
  endif else tooltip_str='right click for options'
  drawID = Widget_Draw(state.id.ibase, /scroll, KEYBOARD_EVENTS=2, $
          /button_events, uvalue='iarea', /ALIGN_CENTER, $
          XSize=NN*state.par.img_zoom, $
          YSize=MM*state.par.img_zoom, $
          X_Scroll_Size= a_dim,$
          Y_Scroll_Size= a_dim,$
          TOOLTIP=tooltip_str)
  Widget_Control, drawID, /Realize
  Widget_Control, drawID, Get_Value=wid
  state.id.iarea = wid
  state.id.ikill = drawID
  Widget_Control, state.id.ibase, Map=1
ENDIF

wset, state.id.iarea

case state.par.img_scale of
  '0': tvscl, CONGRID(zero_padding(img,NN,MM),NN*state.par.img_zoom, MM*state.par.img_zoom)
  '1': begin
       img2=LOGSCL(img, EXPONENT=.5) ;(1./(1. + (0.5/(img>1.e-5))^2.))   ;img+(1e-5*MAX(img))+ABS(min(img))
       tvscl,CONGRID(zero_padding(img2,NN,MM),NN*state.par.img_zoom, MM*state.par.img_zoom)
     end
  '2': tvscl, DOUBLE(CONGRID(zero_padding(img,NN,MM),NN*state.par.img_zoom, MM*state.par.img_zoom)^2.)
  '3': tvscl, SQRT(CONGRID(zero_padding(img,NN,MM),NN*state.par.img_zoom, MM*state.par.img_zoom))
  '4': tvscl, GMASCL(CONGRID(zero_padding(img,NN,MM),NN*state.par.img_zoom, MM*state.par.img_zoom),$
                     gamma=0.2)
  '5': tvscl, GMASCL(CONGRID(zero_padding(img,NN,MM),NN*state.par.img_zoom, MM*state.par.img_zoom),$
                     gamma=0.1)
  
endcase
if state.par.cols*state.par.rows GT 1 then begin
   for x=0,state.par.cols do plots, (x*state.par.domx-1+state.par.overlap)*state.par.img_zoom, $
                                    (indgen(M)+state.par.overlap)*state.par.img_zoom, $
                                    /DEVICE, color='FFFFFF'x, LINESTYLE=2, thick=2.0
   for y=0,state.par.rows do plots, (indgen(N)+state.par.overlap)*state.par.img_zoom, $
                                    (y*state.par.domy-1+state.par.overlap)*state.par.img_zoom, $
                                    /DEVICE, color='FFFFFF'x, LINESTYLE=2, thick=2.0
   
   if ((state.par.domx+state.par.domy)*state.par.img_zoom) GE 51 then begin
 ;     for k=0,state.par.cols*state.par.rows-1 do begin
 ;        xyouts, ((((k mod state.par.cols)+0.5)*state.par.domx)+state.par.overlap)*state.par.img_zoom, $
 ;                ((((k  /  state.par.cols)+0.5)*state.par.domy)+state.par.overlap)*state.par.img_zoom, $
 ;                strtrim(k,1), /DEVICE, charsize=1.5, ALIGNMENT=0.5, charthick=1.
 ;     endfor
       arr=indgen(state.par.cols*state.par.rows)
       xyouts, ((((arr mod state.par.cols)+0.5)*state.par.domx)+state.par.overlap)*state.par.img_zoom, $
               ((((arr  /  state.par.cols)+0.47)*state.par.domy)+state.par.overlap)*state.par.img_zoom, $
               strtrim(indgen(state.par.cols*state.par.rows),1), /DEVICE, charsize=1.5, ALIGNMENT=0.5, charthick=1.
   endif
endif 

return
end

