;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro patch_show_out, state, REDRAW=redraw
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
COMMON image, img, header, N, M, a_dim, Nori, Mori
COMMON output, out, res_array, residual

NN=Nori;N+2*state.par.overlap
MM=Mori;M+2*state.par.overlap

loadct, state.par.img_color, /SILENT

;show image (REDRAW if requested)
IF KEYWORD_SET(redraw) THEN BEGIN
  Widget_Control, state.id.obase, Map=0
  Widget_Control, state.id.okill, /destroy
  if state.par.cols*state.par.rows GT 1 then tooltip_str='right click for options' $
  else tooltip_str='right click for options'
  drawID = Widget_Draw(state.id.obase, /scroll, KEYBOARD_EVENTS=2, $
          /button_events, uvalue='oarea', /ALIGN_CENTER, $
          XSize=NN*state.par.img_zoom, $
          YSize=MM*state.par.img_zoom, $
          X_Scroll_Size= a_dim,$
          Y_Scroll_Size= a_dim,$
          TOOLTIP=tooltip_str)
  Widget_Control, drawID, /Realize
  Widget_Control, drawID, Get_Value=wid
  state.id.oarea = wid
  state.id.okill = drawID
  Widget_Control, state.id.obase, Map=1
ENDIF

wset, state.id.oarea

case state.par.img_scale of
  '0': tvscl, CONGRID(zero_padding(out,NN,MM),NN*state.par.img_zoom, MM*state.par.img_zoom)
  '1': begin
       img2=LOGSCL(out>0., EXPONENT=.5) ;(1./(1. + (0.5/(img>1.e-5))^2.))   ;img+(1e-5*MAX(img))+ABS(min(img))
       tvscl,CONGRID(zero_padding(img2,NN,MM),NN*state.par.img_zoom, MM*state.par.img_zoom)
     end
  '2': tvscl, DOUBLE(CONGRID(zero_padding(out,NN,MM),NN*state.par.img_zoom, MM*state.par.img_zoom)^2.)
  '3': tvscl, SQRT(CONGRID(zero_padding(out,NN,MM),NN*state.par.img_zoom, MM*state.par.img_zoom))
  '4': tvscl, GMASCL(CONGRID(zero_padding(out,NN,MM),NN*state.par.img_zoom, MM*state.par.img_zoom),$
                     gamma=0.2)
  '5': tvscl, GMASCL(CONGRID(zero_padding(out,NN,MM),NN*state.par.img_zoom, MM*state.par.img_zoom),$
                     gamma=0.1)
                     
endcase

                        
return
end

